(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('../../pfelement/dist/pfelement.umd')) :
  typeof define === 'function' && define.amd ? define(['../../pfelement/dist/pfelement.umd'], factory) :
  (global.PfeDocumentation = factory(global.PFElement));
}(this, (function (PFElement) { 'use strict';

  PFElement = PFElement && PFElement.hasOwnProperty('default') ? PFElement['default'] : PFElement;

  var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  };

  var classCallCheck = function (instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  };

  var createClass = function () {
    function defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    return function (Constructor, protoProps, staticProps) {
      if (protoProps) defineProperties(Constructor.prototype, protoProps);
      if (staticProps) defineProperties(Constructor, staticProps);
      return Constructor;
    };
  }();

  var get = function get(object, property, receiver) {
    if (object === null) object = Function.prototype;
    var desc = Object.getOwnPropertyDescriptor(object, property);

    if (desc === undefined) {
      var parent = Object.getPrototypeOf(object);

      if (parent === null) {
        return undefined;
      } else {
        return get(parent, property, receiver);
      }
    } else if ("value" in desc) {
      return desc.value;
    } else {
      var getter = desc.get;

      if (getter === undefined) {
        return undefined;
      }

      return getter.call(receiver);
    }
  };

  var inherits = function (subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        enumerable: false,
        writable: true,
        configurable: true
      }
    });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
  };

  var possibleConstructorReturn = function (self, call) {
    if (!self) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return call && (typeof call === "object" || typeof call === "function") ? call : self;
  };

  /*!
   * PatternFly Elements: PfeDocumentation 1.0.0-prerelease.45
   * @license
   * Copyright 2020 Red Hat, Inc.
   * 
   * Permission is hereby granted, free of charge, to any person obtaining a copy
   * of this software and associated documentation files (the "Software"), to deal
   * in the Software without restriction, including without limitation the rights
   * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
   * copies of the Software, and to permit persons to whom the Software is
   * furnished to do so, subject to the following conditions:
   * 
   * The above copyright notice and this permission notice shall be included in
   * all copies or substantial portions of the Software.
   * 
   * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
   * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
   * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
   * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
   * SOFTWARE.
   * 
  */

  // Config for mutation observer to see if things change inside of the component
  var lightDomObserverConfig = {
    characterData: true,
    attributes: true,
    subtree: true,
    childList: true
  };

  var PfeDocumentation = function (_PFElement) {
    inherits(PfeDocumentation, _PFElement);
    createClass(PfeDocumentation, [{
      key: "html",
      get: function get$$1() {
        return "<style>:host{display:block}:host([hidden]){display:none}\n/*# sourceMappingURL=cp-documentation.min.css.map */\n</style><div id=\"wrapper\"></div>";
      }
    }, {
      key: "schemaUrl",
      get: function get$$1() {
        return "cp-documentation.json";
      }
    }, {
      key: "templateUrl",
      get: function get$$1() {
        return "cp-documentation.html";
      }
    }, {
      key: "styleUrl",
      get: function get$$1() {
        return "cp-documentation.scss";
      }
    }], [{
      key: "version",
      get: function get$$1() {
        return "1.0.0-prerelease.45";
      }
    }, {
      key: "properties",
      get: function get$$1() {
        return { "loaded": { "title": "Loaded", "type": "string", "enum": [], "default": "", "prefixed": true }, " endpoint": { "title": " endpoint", "type": "string", "enum": [], "default": "", "prefixed": true }, " css": { "title": " css", "type": "string", "enum": [], "default": "", "prefixed": true } };
      }
    }, {
      key: "slots",
      get: function get$$1() {
        return { "default": { "title": "Default slot", "type": "array", "namedSlot": false, "items": { "oneOf": [{ "$ref": "raw" }] } } };
      }
    }, {
      key: "tag",
      get: function get$$1() {
        return "cp-documentation";
      }
    }, {
      key: "events",
      get: function get$$1() {
        return {
          change: this.tag + ":change",
          loaded: this.tag + ":loaded"
        };
      }

      // Declare the type of this component

    }, {
      key: "PfeType",
      get: function get$$1() {
        return PFElement.PfeTypes.Container;
      }
    }, {
      key: "observedAttributes",
      get: function get$$1() {
        return ["pfe-loaded", "pfe-endpoint", "pfe-css"];
      }
    }]);

    function PfeDocumentation() {
      classCallCheck(this, PfeDocumentation);

      // Ensure 'this' is tied to the component object in these member functions
      var _this = possibleConstructorReturn(this, (PfeDocumentation.__proto__ || Object.getPrototypeOf(PfeDocumentation)).call(this, PfeDocumentation, { type: PfeDocumentation.PfeType }));

      _this._processLightDom = _this._processLightDom.bind(_this);
      _this._loadCss = _this._loadCss.bind(_this);
      _this.loadData = _this.loadData.bind(_this);
      _this.getData = _this.getData.bind(_this);

      // Setup mutation observer to watch for content changes
      _this._observer = new MutationObserver(_this._processLightDom);

      // Initialize object to store data in
      _this._moduleData = {};
      return _this;
    }

    createClass(PfeDocumentation, [{
      key: "connectedCallback",
      value: function connectedCallback() {
        get(PfeDocumentation.prototype.__proto__ || Object.getPrototypeOf(PfeDocumentation.prototype), "connectedCallback", this).call(this);

        this._processLightDom();

        this._observer.observe(this, lightDomObserverConfig);

        this.addEventListener(PfeDocumentation.events.change, this._changeHandler);
        this.addEventListener(PfeDocumentation.events.loaded, this._loadedHandler);

        if (this.hasAttribute("pfe-css")) {
          this._loadCss();
        }
      }
    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this.removeEventListener(PfeDocumentation.events.change, this._changeHandler);
        this.removeEventListener(PfeDocumentation.events.loaded, this._loadedHandler);
      }
    }, {
      key: "attributeChangedCallback",
      value: function attributeChangedCallback(attr, oldVal, newVal) {
        get(PfeDocumentation.prototype.__proto__ || Object.getPrototypeOf(PfeDocumentation.prototype), "attributeChangedCallback", this).call(this, attr, oldVal, newVal);

        switch (attr) {
          case "pfe-endpoint":
            this.loadData();
            break;
        }
      }

      /**
       * Handle initialization or changes in light DOM
       * Clone them into the shadowRoot
       */

    }, {
      key: "_processLightDom",
      value: function _processLightDom() {
        // Preventing issues in IE11 & Edge
        if (window.ShadyCSS) {
          this._observer.disconnect();
        }

        var shadowWrapper = this.shadowRoot.getElementById("wrapper"),
            oldContentWrapper = this.shadowRoot.getElementById("content"),

        // An element that light dom content will be put into and replaces the shadowWrapper at the end
        newContentWrapper = document.createElement("div");

        this.childNodes.forEach(function (childNode) {
          var cloneNode = childNode.cloneNode(true);
          newContentWrapper.append(cloneNode);
        });

        if (oldContentWrapper) {
          shadowWrapper.replaceChild(newContentWrapper, oldContentWrapper);
        } else {
          shadowWrapper.append(newContentWrapper);
        }
        newContentWrapper.setAttribute("id", "content");

        // Reconnecting mutationObserver for IE11 & Edge
        if (window.ShadyCSS) {
          this._observer.observe(this, lightDomObserverConfig);
        }
      }
    }, {
      key: "_loadCss",
      value: function _loadCss() {
        // If we have an attribute and the CSS hasn't been loaded yet
        if (this.hasAttribute("pfe-css") && !this.shadowRoot.getElementById("pfe-css")) {
          var pfeCssUrl = this.getAttribute("pfe-css");
          var linkTag = document.createElement("link");
          linkTag.setAttribute("id", "pfe-css");
          linkTag.setAttribute("href", pfeCssUrl);
          linkTag.setAttribute("rel", "stylesheet");
          this.shadowRoot.append(linkTag);
        }
      }

      /**
       * Get the content from pfe-endpoint attribute
       *
       * Also loads the body content
       */

    }, {
      key: "loadData",
      value: function loadData() {
        var _this2 = this;

        var endpointUrl = this.getAttribute("pfe-endpoint");
        // @todo local caching?
        if (endpointUrl) {
          fetch(endpointUrl).then(function (response) {
            return response.json();
          }).then(function (data) {
            console.log(data);
            if (_typeof(data.module) === "object") {
              _this2.setAttribute("pfe-loaded", "");
              _this2._moduleData = data.module;
              if (_this2._moduleData.body) {
                _this2.innerHTML = _this2._moduleData.body;
              }
            }
          }).catch(function (error) {
            return console.log(_this2.tag + ": " + error);
          });
        }
      }

      /**
       * Allows parent DOM to access the module data
       * @return {object} The module data
       */

    }, {
      key: "getData",
      value: function getData() {
        if (Object.keys(this._moduleData).length) {
          return this._moduleData;
        }

        return null;
      }
    }, {
      key: "_changeHandler",
      value: function _changeHandler(event) {
        this.emitEvent(PfeDocumentation.events.change, {
          detail: {}
        });
      }
    }, {
      key: "_loadedHandler",
      value: function _loadedHandler(event) {
        this.emitEvent(PfeDocumentation.events.loaded, {
          detail: {}
        });
      }
    }]);
    return PfeDocumentation;
  }(PFElement);

  PFElement.create(PfeDocumentation);

  return PfeDocumentation;

})));
//# sourceMappingURL=cp-documentation.umd.js.map
